/*  Custom Quest Set Generator - Functions relative to the GUI and
    writing the data gathering by the GUI.

    Copyright (C) 2010-2011 Tartine

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <gtk/gtk.h>
#include "skin.h"
#include "fonction.h"

void quit(void)
{
  remove("temp");
  gtk_main_quit();
}

void combo_box_clear (GtkComboBox *p_combo_box)
{
  GtkTreeModel *p_tree_model = NULL;

  g_return_if_fail (p_combo_box != NULL);

  p_tree_model = gtk_combo_box_get_model (p_combo_box);
  gtk_list_store_clear (GTK_LIST_STORE (p_tree_model));
}

void aff_objets(GtkComboBox* data)
{
    FILE* cotte = NULL;
    char chaine[51] = {'\0'};
    int i = 0;

    cotte = fopen("rc/objet", "r+");

    if(cotte == NULL)
    {
      printf("Error: aff_objets(): fopen()\n");
      exit(-1);
    }

    while(fgets(chaine, 50, cotte) != NULL && i <= 193)
    {
        int size = strlen(chaine);

        if(chaine[size] == '\n')
        {
          chaine[size] = '\0';
        }

        gtk_combo_box_append_text(GTK_COMBO_BOX(data), chaine);
        i++;
    }

}

void aff_cotte(GtkComboBox* data)
{
    FILE* cotte = NULL;
    char chaine[51] = {'\0'};

    cotte = fopen("rc/cotte", "r+");

    if(cotte == NULL)
    {
      printf("Error: aff_cotte(): fopen()\n");
      exit(-1);
    }

    while(fgets(chaine, 50, cotte) != NULL)
    {
        int size = strlen(chaine);

        if(chaine[size] == '\n')
        {
          chaine[size] = '\0';
        }

        gtk_combo_box_append_text(GTK_COMBO_BOX(data), chaine);
    }

}

void aff_gants(GtkComboBox* data)
{
    FILE* cotte = NULL;
    char chaine[51] = {'\0'};

    cotte = fopen("rc/gants", "r+");

    if(cotte == NULL)
    {
      printf("Error: aff_gants(): fopen()\n");
      exit(-1);
    }

    while(fgets(chaine, 50, cotte) != NULL)
    {
        int size = strlen(chaine);

        if(chaine[size] == '\n')
        {
          chaine[size] = '\0';
        }

        gtk_combo_box_append_text(GTK_COMBO_BOX(data), chaine);
    }

}

void aff_taille(GtkComboBox* data)
{
    FILE* cotte = NULL;
    char chaine[51] = {'\0'};

    cotte = fopen("rc/taille", "r+");

    if(cotte == NULL)
    {
      printf("Error: aff_taille(): fopen()\n");
      exit(-1);
    }

    while(fgets(chaine, 50, cotte) != NULL)
    {
        int size = strlen(chaine);

        if(chaine[size] == '\n')
        {
          chaine[size] = '\0';
        }

        gtk_combo_box_append_text(GTK_COMBO_BOX(data), chaine);
    }

}

void aff_jambes(GtkComboBox* data)
{
    FILE* cotte = NULL;
    char chaine[51] = {'\0'};

    cotte = fopen("rc/jambes", "r+");

    if(cotte == NULL)
    {
      printf("Error: aff_jambes(): fopen()\n");
      exit(-1);
    }

    while(fgets(chaine, 50, cotte) != NULL)
    {
        int size = strlen(chaine);

        if(chaine[size] == '\n')
        {
          chaine[size] = '\0';
        }

        gtk_combo_box_append_text(GTK_COMBO_BOX(data), chaine);
    }

}

void aff_casque(GtkComboBox* data)
{
    FILE* cotte = NULL;
    char chaine[51] = {'\0'};

    cotte = fopen("rc/casque", "r+");

    if(cotte == NULL)
    {
      printf("Error: aff_casque(): fopen()\n");
      exit(-1);
    }

    while(fgets(chaine, 50, cotte) != NULL)
    {
        int size = strlen(chaine);

        if(chaine[size] == '\n')
        {
          chaine[size] = '\0';
        }

        gtk_combo_box_append_text(GTK_COMBO_BOX(data), chaine);
    }

}

void aff_joyau(GtkComboBox* data)
{
  FILE* joyau = NULL;
  char chaine[51] = {'\0'};

  joyau = fopen("rc/joyau", "r+");

  if(joyau == NULL)
  {
    printf("Error: aff_joyau(): fopen()\n");
    exit(-1);
  }

  while(fgets(chaine, 50, joyau) != NULL)
  {
      int size = strlen(chaine);

      if(chaine[size] == '\n')
      {
        chaine[size] = '\0';
      }

      gtk_combo_box_append_text(GTK_COMBO_BOX(data), chaine);
  }
}

void aff_arme(GtkWidget* widget, gpointer data)
{
  int i = 0;
  char chaine[50] = {'\0'};
  FILE* in = NULL;

  i = gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(widget));

  combo_box_clear(GTK_COMBO_BOX(data));

  switch(i)
  {
    case 5:
   in = fopen("rc/gs", "r+");
    if(in == NULL)
    {
        printf("Error: aff_arme(): fopen(gs)\n");
        exit(-1);
    }
    break;

    case 6:
    in = fopen("rc/sns", "r+");
    if(in == NULL)
    {
        printf("Error: aff_arme(): fopen(sns)\n");
        exit(-1);
    }
    break;

    case 7:
    in = fopen("rc/marteau", "r+");
    if(in == NULL)
    {
        printf("Error: aff_arme(): fopen(marteau)\n");
        exit(-1);
    }
    break;

    case 8:
    in = fopen("rc/lance", "r+");
    if(in == NULL)
    {
        printf("Error: aff_arme(): fopen(lance)\n");
        exit(-1);
    }
    break;

    case 9:
    in = fopen("rc/fusarbh", "r+");
    if(in == NULL)
    {
        printf("Error: aff_arme(): fopen(fusarbh)\n");
        exit(-1);
    }
    break;

    case 10:
    in = fopen("rc/fusarbl", "r+");
    if(in == NULL)
    {
        printf("Error: aff_arme(): fopen(fusarbl)\n");
        exit(-1);
    }
    break;

    case 11:
    in = fopen("rc/katana", "r+");
    if(in == NULL)
    {
        printf("Error: aff_arme(): fopen(katana)\n");
        exit(-1);
    }
    break;

    case 12:
    in = fopen("rc/morpho", "r+");
    if(in == NULL)
    {
        printf("Error: aff_arme(): fopen(morpho)\n");
        exit(-1);
    }
    break;

    case 13:
    in = fopen("rc/gunlance", "r+");
    if(in == NULL)
    {
        printf("Error: aff_arme(): fopen(gunlance)\n");
        exit(-1);
    }
    break;

    case 14:
    in = fopen("rc/arc", "r+");
    if(in == NULL)
    {
        printf("Error: aff_arme(): fopen(arc)\n");
        exit(-1);
    }
    break;

    case 15:
    in = fopen("rc/ds", "r+");
    if(in == NULL)
    {
        printf("Error: aff_arme(): fopen(ds)\n");
        exit(-1);
    }
    break;

    case 16:
    in = fopen("rc/hh", "r+");
    if(in == NULL)
    {
        printf("Error: aff_arme(): fopen(hh)\n");
        exit(-1);
    }
    break;

    default:
    in = fopen("rc/gs", "r+");
    if(in == NULL)
    {
        printf("Error: aff_arme(): fopen(gs)\n");
        exit(-1);
    }
    break;
  }

    while(fgets(chaine, 50, in) != NULL)
    {
      int size = strlen(chaine);

      if(chaine[size] == '\n')
      {
        chaine[size] = '\0';
      }

      gtk_combo_box_append_text(GTK_COMBO_BOX(data), chaine);
    }
    fclose(in);
}

void print_jambes(GtkWidget* widget, gpointer part)
{
  FILE* out = NULL;
  FILE* jambes = NULL;
  FILE* joyau = NULL;
  int i = 0;
  char chaine[51] = {'\0'};
  Set* test = (Set*)part;

  out = fopen("set.set", "r+");
  jambes = fopen("rc/jambes", "r+");
  joyau = fopen("rc/joyau", "r+");

  if(out == NULL)
  {
      printf("Error: print_jambes(): fopen(set.set)\n");
      exit(-1);
  }

  if(jambes == NULL)
  {
      printf("Error; print_jambes(): fopen(jambes)\n");
      exit(-1);
  }

  if(joyau == NULL)
  {
      printf("Error: print_jambes(): fopen(joyau)\n");
      exit(-1);
  }

  fseek(out, 0, SEEK_END);

  if(gtk_combo_box_get_active_text(GTK_COMBO_BOX(test->part)) != NULL)
  {
    while(fgets(chaine, 50, jambes) != NULL && strcmp(chaine, gtk_combo_box_get_active_text(GTK_COMBO_BOX(test->part))) != 0)
    {
      i++;
    }

    fprintf(out, "jambes:\n%d ", i);
  }

  else
  {
      fprintf(out, "jambes:\n0 ");
  }

  if(gtk_combo_box_get_active_text(GTK_COMBO_BOX(test->j1)) != NULL)
  {
    i = 816;
    while(fgets(chaine, 50, joyau) != NULL && strcmp(chaine, gtk_combo_box_get_active_text(GTK_COMBO_BOX(test->j1))) != 0);
    {
      i++;
    }

    fprintf(out, "%d ", i);
  }

  else
  {
      fprintf(out, "0 ");
  }

  if(gtk_combo_box_get_active_text(GTK_COMBO_BOX(test->j2)) != NULL)
  {
    i = 816;
    while(fgets(chaine, 50, joyau) != NULL && strcmp(chaine, gtk_combo_box_get_active_text(GTK_COMBO_BOX(test->j2))) != 0);
    {
      i++;
    }

    fprintf(out, "%d ", i);
  }

  else
  {
      fprintf(out, "0 ");
  }


  if(gtk_combo_box_get_active_text(GTK_COMBO_BOX(test->j3)) != NULL)
  {
    i = 816;
    while(fgets(chaine, 50, joyau) != NULL && strcmp(chaine, gtk_combo_box_get_active_text(GTK_COMBO_BOX(test->j3))) != 0);
    {
      i++;
    }

    fprintf(out, "%d\n", i);
  }

  else
  {
      fprintf(out, "0\n");
  }

  fclose(joyau);
  fclose(jambes);
  fclose(out);
}

void print_casque(GtkWidget* widget, gpointer part)
{
  FILE* out = NULL;
  FILE* casque = NULL;
  FILE* joyau = NULL;
  int i = 0;
  char chaine[51] = {'\0'};
  Set* test = (Set*)part;

  out = fopen("set.set", "r+");
  casque = fopen("rc/casque", "r+");
  joyau = fopen("rc/joyau", "r+");

  if(out == NULL)
  {
      printf("Error: print_casque(): fopen(set.set)\n");
      exit(-1);
  }

  if(casque == NULL)
  {
      printf("Error; print_casque(): fopen(casque)\n");
      exit(-1);
  }

  if(joyau == NULL)
  {
      printf("Error: print_casque(): fopen(joyau)\n");
      exit(-1);
  }

  fseek(out, 0, SEEK_END);

  if(gtk_combo_box_get_active_text(GTK_COMBO_BOX(test->part)) != NULL)
  {
    while(fgets(chaine, 50, casque) != NULL && strcmp(chaine, gtk_combo_box_get_active_text(GTK_COMBO_BOX(test->part))) != 0)
    {
      i++;
    }

    fprintf(out, "casque:\n%d ", i);
  }

  else
  {
      fprintf(out, "casque:\n0 ");
  }

  if(gtk_combo_box_get_active_text(GTK_COMBO_BOX(test->j1)) != NULL)
  {
    i = 816;
    while(fgets(chaine, 50, joyau) != NULL && strcmp(chaine, gtk_combo_box_get_active_text(GTK_COMBO_BOX(test->j1))) != 0);
    {
      i++;
    }

    fprintf(out, "%d ", i);
  }

  else
  {
      fprintf(out, "0 ");
  }

  if(gtk_combo_box_get_active_text(GTK_COMBO_BOX(test->j2)) != NULL)
  {
    i = 816;
    while(fgets(chaine, 50, joyau) != NULL && strcmp(chaine, gtk_combo_box_get_active_text(GTK_COMBO_BOX(test->j2))) != 0);
    {
      i++;
    }

    fprintf(out, "%d ", i);
  }

  else
  {
      fprintf(out, "0 ");
  }


  if(gtk_combo_box_get_active_text(GTK_COMBO_BOX(test->j3)) != NULL)
  {
    i = 816;
    while(fgets(chaine, 50, joyau) != NULL && strcmp(chaine, gtk_combo_box_get_active_text(GTK_COMBO_BOX(test->j3))) != 0);
    {
      i++;
    }

    fprintf(out, "%d\n", i);
  }

  else
  {
      fprintf(out, "0\n");
  }

  fclose(joyau);
  fclose(casque);
  fclose(out);
}

void print_taille(GtkWidget* widget, gpointer part)
{
  FILE* out = NULL;
  FILE* taille = NULL;
  FILE* joyau = NULL;
  int i = 0;
  char chaine[51] = {'\0'};
  Set* test = (Set*)part;

  out = fopen("set.set", "r+");
  taille = fopen("rc/taille", "r+");
  joyau = fopen("rc/joyau", "r+");

  if(out == NULL)
  {
      printf("Error: print_taille(): fopen(set.set)\n");
      exit(-1);
  }

  if(taille == NULL)
  {
      printf("Error; print_taille(): fopen(taille)\n");
      exit(-1);
  }

  if(joyau == NULL)
  {
      printf("Error: print_taille(): fopen(joyau)\n");
      exit(-1);
  }

  fseek(out, 0, SEEK_END);

  if(gtk_combo_box_get_active_text(GTK_COMBO_BOX(test->part)) != NULL)
  {
    while(fgets(chaine, 50, taille) != NULL && strcmp(chaine, gtk_combo_box_get_active_text(GTK_COMBO_BOX(test->part))) != 0)
    {
      i++;
    }

    fprintf(out, "taille:\n%d ", i);
  }

  else
  {
      fprintf(out, "taille:\n0 ");
  }

  if(gtk_combo_box_get_active_text(GTK_COMBO_BOX(test->j1)) != NULL)
  {
    i = 816;
    while(fgets(chaine, 50, joyau) != NULL && strcmp(chaine, gtk_combo_box_get_active_text(GTK_COMBO_BOX(test->j1))) != 0);
    {
      i++;
    }

    fprintf(out, "%d ", i);
  }

  else
  {
      fprintf(out, "0 ");
  }

  if(gtk_combo_box_get_active_text(GTK_COMBO_BOX(test->j2)) != NULL)
  {
    i = 816;
    while(fgets(chaine, 50, joyau) != NULL && strcmp(chaine, gtk_combo_box_get_active_text(GTK_COMBO_BOX(test->j2))) != 0);
    {
      i++;
    }

    fprintf(out, "%d ", i);
  }

  else
  {
      fprintf(out, "0 ");
  }


  if(gtk_combo_box_get_active_text(GTK_COMBO_BOX(test->j3)) != NULL)
  {
    i = 816;
    while(fgets(chaine, 50, joyau) != NULL && strcmp(chaine, gtk_combo_box_get_active_text(GTK_COMBO_BOX(test->j3))) != 0);
    {
      i++;
    }

    fprintf(out, "%d\n", i);
  }

  else
  {
      fprintf(out, "0\n");
  }

  fclose(joyau);
  fclose(taille);
  fclose(out);
}




void print_gants(GtkWidget* widget, gpointer part)
{
  FILE* out = NULL;
  FILE* gants = NULL;
  FILE* joyau = NULL;
  int i = 0;
  char chaine[51] = {'\0'};
  Set* test = (Set*)part;

  out = fopen("set.set", "r+");
  gants = fopen("rc/gants", "r+");
  joyau = fopen("rc/joyau", "r+");

  if(out == NULL)
  {
      printf("Error: print_gants(): fopen(set.set)\n");
      exit(-1);
  }

  if(gants == NULL)
  {
      printf("Error; print_gants(): fopen(gants)\n");
      exit(-1);
  }

  if(joyau == NULL)
  {
      printf("Error: print_cotte(): fopen(joyau)\n");
      exit(-1);
  }

  fseek(out, 0, SEEK_END);

  if(gtk_combo_box_get_active_text(GTK_COMBO_BOX(test->part)) != NULL)
  {
    while(fgets(chaine, 50, gants) != NULL && strcmp(chaine, gtk_combo_box_get_active_text(GTK_COMBO_BOX(test->part))) != 0)
    {
      i++;
    }

    fprintf(out, "gants:\n%d ", i);
  }

  else
  {
      fprintf(out, "gants:\n0 ");
  }

  if(gtk_combo_box_get_active_text(GTK_COMBO_BOX(test->j1)) != NULL)
  {
    i = 816;
    while(fgets(chaine, 50, joyau) != NULL && strcmp(chaine, gtk_combo_box_get_active_text(GTK_COMBO_BOX(test->j1))) != 0);
    {
      i++;
    }

    fprintf(out, "%d ", i);
  }

  else
  {
      fprintf(out, "0 ");
  }

  if(gtk_combo_box_get_active_text(GTK_COMBO_BOX(test->j2)) != NULL)
  {
    i = 816;
    while(fgets(chaine, 50, joyau) != NULL && strcmp(chaine, gtk_combo_box_get_active_text(GTK_COMBO_BOX(test->j2))) != 0);
    {
      i++;
    }

    fprintf(out, "%d ", i);
  }

  else
  {
      fprintf(out, "0 ");
  }


  if(gtk_combo_box_get_active_text(GTK_COMBO_BOX(test->j3)) != NULL)
  {
    i = 816;
    while(fgets(chaine, 50, joyau) != NULL && strcmp(chaine, gtk_combo_box_get_active_text(GTK_COMBO_BOX(test->j3))) != 0);
    {
      i++;
    }

    fprintf(out, "%d\n", i);
  }

  else
  {
      fprintf(out, "0\n");
  }

  fclose(joyau);
  fclose(gants);
  fclose(out);
}

void print_cotte(GtkWidget* widget, gpointer part)
{
  FILE* out = NULL;
  FILE* cotte = NULL;
  FILE* joyau = NULL;
  int i = 0;
  char chaine[51] = {'\0'};
  Set* test = (Set*)part;

  out = fopen("set.set", "w+");
  cotte = fopen("rc/cotte", "r+");
  joyau = fopen("rc/joyau", "r+");

  if(out == NULL)
  {
      printf("Error: print_cotte(): fopen(set.set)\n");
      exit(-1);
  }

  if(cotte == NULL)
  {
      printf("Error; print_cotte(): fopen(cotte)\n");
      exit(-1);
  }

  if(joyau == NULL)
  {
      printf("Error: print_cotte(): fopen(joyau)\n");
      exit(-1);
  }

  if(gtk_combo_box_get_active_text(GTK_COMBO_BOX(test->part)) != NULL)
  {
    while(fgets(chaine, 50, cotte) != NULL && strcmp(chaine, gtk_combo_box_get_active_text(GTK_COMBO_BOX(test->part))) != 0)
    {
      i++;
    }

    fprintf(out, "1\nbegin set:\ntorse:\n%d ", i);
  }

  else
  {
      fprintf(out, "1\nbegin set:\ntorse:\n0 ");
  }

  if(gtk_combo_box_get_active_text(GTK_COMBO_BOX(test->j1)) != NULL)
  {
    i = 816;
    while(fgets(chaine, 50, joyau) != NULL && strcmp(chaine, gtk_combo_box_get_active_text(GTK_COMBO_BOX(test->j1))) != 0);
    {
      i++;
    }

    fprintf(out, "%d ", i);
  }

  else
  {
      fprintf(out, "0 ");
  }

  if(gtk_combo_box_get_active_text(GTK_COMBO_BOX(test->j2)) != NULL)
  {
    i = 816;
    while(fgets(chaine, 50, joyau) != NULL && strcmp(chaine, gtk_combo_box_get_active_text(GTK_COMBO_BOX(test->j2))) != 0);
    {
      i++;
    }

    fprintf(out, "%d ", i);
  }

  else
  {
      fprintf(out, "0 ");
  }


  if(gtk_combo_box_get_active_text(GTK_COMBO_BOX(test->j3)) != NULL)
  {
    i = 816;
    while(fgets(chaine, 50, joyau) != NULL && strcmp(chaine, gtk_combo_box_get_active_text(GTK_COMBO_BOX(test->j3))) != 0);
    {
      i++;
    }

    fprintf(out, "%d\n", i);
  }

  else
  {
      fprintf(out, "0\n");
  }

  fclose(joyau);
  fclose(cotte);
  fclose(out);
}

void print_arme(GtkWidget* widget, gpointer data)
{
  int i = 0;
  int a = 0;
  char chaine[50] = {'\0'};
  FILE* in = NULL;
  FILE* out = NULL;
  FILE* joyau = NULL;
  Weapon* test = (Weapon*)data;

  i = gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(test->swap));

  out = fopen("set.set", "r+");

  if(out == NULL)
  {
      printf("Error: print_arme(): fopen(set.set)\n");
      exit(-1);
  }

  joyau = fopen("rc/joyau", "r+");

  if(joyau == NULL)
  {
      printf("Error: print_arme(): fopen(joyau)\n");
      exit(-1);
  }

  switch(i)
  {
    case 5:
   in = fopen("rc/gs", "r+");
    if(in == NULL)
    {
        printf("Error: aff_arme(): fopen(gs)\n");
        exit(-1);
    }
    break;

    case 6:
    in = fopen("rc/sns", "r+");
    if(in == NULL)
    {
        printf("Error: aff_arme(): fopen(sns)\n");
        exit(-1);
    }
    break;

    case 7:
    in = fopen("rc/marteau", "r+");
    if(in == NULL)
    {
        printf("Error: aff_arme(): fopen(marteau)\n");
        exit(-1);
    }
    break;

    case 8:
    in = fopen("rc/lance", "r+");
    if(in == NULL)
    {
        printf("Error: aff_arme(): fopen(lance)\n");
        exit(-1);
    }
    break;

    case 9:
    in = fopen("rc/fusarbh", "r+");
    if(in == NULL)
    {
        printf("Error: aff_arme(): fopen(fusarbh)\n");
        exit(-1);
    }
    break;

    case 10:
    in = fopen("rc/fusarbl", "r+");
    if(in == NULL)
    {
        printf("Error: aff_arme(): fopen(fusarbl)\n");
        exit(-1);
    }
    break;

    case 11:
    in = fopen("rc/katana", "r+");
    if(in == NULL)
    {
        printf("Error: aff_arme(): fopen(katana)\n");
        exit(-1);
    }
    break;

    case 12:
    in = fopen("rc/morpho", "r+");
    if(in == NULL)
    {
        printf("Error: aff_arme(): fopen(morpho)\n");
        exit(-1);
    }
    break;

    case 13:
    in = fopen("rc/gunlance", "r+");
    if(in == NULL)
    {
        printf("Error: aff_arme(): fopen(gunlance)\n");
        exit(-1);
    }
    break;

    case 14:
    in = fopen("rc/arc", "r+");
    if(in == NULL)
    {
        printf("Error: aff_arme(): fopen(arc)\n");
        exit(-1);
    }
    break;

    case 15:
    in = fopen("rc/ds", "r+");
    if(in == NULL)
    {
        printf("Error: aff_arme(): fopen(ds)\n");
        exit(-1);
    }
    break;

    case 16:
    in = fopen("rc/hh", "r+");
    if(in == NULL)
    {
        printf("Error: aff_arme(): fopen(hh)\n");
        exit(-1);
    }
    break;

    default:
    in = fopen("rc/gs", "r+");
    if(in == NULL)
    {
        printf("Error: aff_arme(): fopen(gs)\n");
        exit(-1);
    }
    break;
  }

  fseek(out, 0, SEEK_END);

  if(gtk_combo_box_get_active_text(GTK_COMBO_BOX(test->arme)) != NULL)
  {
    while(fgets(chaine, 50, in) != NULL && strcmp(chaine, gtk_combo_box_get_active_text(GTK_COMBO_BOX(test->arme))) != 0)
    {
      a++;
    }

    fprintf(out, "arme:\n%d %d ", i, a);
  }

  else
  {
    fprintf(out, "arme:\n5 0 ");
  }

    if(gtk_combo_box_get_active_text(GTK_COMBO_BOX(test->j1)) != NULL)
  {
    i = 816;
    while(fgets(chaine, 50, joyau) != NULL && strcmp(chaine, gtk_combo_box_get_active_text(GTK_COMBO_BOX(test->j1))) != 0);
    {
      i++;
    }

    fprintf(out, "%d ", i);
  }

  else
  {
      fprintf(out, "0 ");
  }

  if(gtk_combo_box_get_active_text(GTK_COMBO_BOX(test->j2)) != NULL)
  {
    i = 816;
    while(fgets(chaine, 50, joyau) != NULL && strcmp(chaine, gtk_combo_box_get_active_text(GTK_COMBO_BOX(test->j2))) != 0);
    {
      i++;
    }

    fprintf(out, "%d ", i);
  }

  else
  {
      fprintf(out, "0 ");
  }


  if(gtk_combo_box_get_active_text(GTK_COMBO_BOX(test->j3)) != NULL)
  {
    i = 816;
    while(fgets(chaine, 50, joyau) != NULL && strcmp(chaine, gtk_combo_box_get_active_text(GTK_COMBO_BOX(test->j3))) != 0);
    {
      i++;
    }

    fprintf(out, "%d\n", i);
  }

  else
  {
      fprintf(out, "0\n");
  }

  fclose(in);
  fclose(joyau);
  fclose(out);
}

void count_obj(GtkWidget* widget, gpointer data)
{

  FILE* obj = fopen("rc/objet", "r+");
  FILE* temp = NULL;
  char chaine[51] = {'\0'};
  int i = 0;
  int var = 0;
  Object* test = (Object*)data;

  temp = fopen("temp", "r+");

  if(temp == NULL)
  {
    temp = fopen("temp", "w+");
    fprintf(temp, "0");
  }

  if(gtk_combo_box_get_active_text(GTK_COMBO_BOX(test->combo)) != NULL)
  {
      while(fgets(chaine, 50, obj) != NULL && strcmp(chaine, gtk_combo_box_get_active_text(GTK_COMBO_BOX(test->combo))) != 0)
      {
        if(strstr(chaine, "Aucun Objet") != NULL)
        {
          i++;
        }
      }

      if(i > 0)
      {
        fscanf(temp, "%d", &var);
        var++;
        rewind(temp);
        fprintf(temp, "%d", var);
      }
  }

  fclose(obj);
  fclose(temp);
}

void print_nb(GtkWidget* widget, gpointer data)
{
  FILE* temp = NULL;
  FILE* out = NULL;
  int nb = 0;

  out = fopen("set.set", "r+");
  temp = fopen("temp", "r+");

  fseek(out, 0, SEEK_END);

  fscanf(temp, "%d", &nb);

  fprintf(out, "objets:\n%d\n", nb);

  fclose(temp);
  fclose(out);
}


void print_objet(GtkWidget* widget, gpointer data)
{
    FILE* out = NULL;
    FILE* obj = NULL;
    char chaine[51] = {'\0'};
    Object* test = (Object*)data;
    int i = 1;

    out = fopen("set.set", "r+");

    if(out == NULL)
    {
      printf("Error: print_objet(): fopen(set.set)\n");
      exit(-1);
    }

    obj = fopen("rc/objet", "r+");

    if(obj == NULL)
    {
        printf("Erreur: print_objet(): fopen(objet)\n");
        exit(-1);
    }

    fseek(out, 0, SEEK_END);
    if(gtk_combo_box_get_active_text(GTK_COMBO_BOX(test->combo)) != NULL)
    {
      while(fgets(chaine, 50, obj) != NULL && strcmp(chaine, gtk_combo_box_get_active_text(GTK_COMBO_BOX(test->combo))) != 0)
      {
          i++;
      }

      fprintf(out, "%d ,", i-1);

      i = gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(test->spin));

      fprintf(out, "%d ", i);
    }

  fclose(out);
  fclose(obj);
}

void done(GtkWidget *pBtn, gpointer data)
{
    GtkWidget* pAbout = NULL;
    GtkWidget* url = NULL;
    gchar *sSite = "Le fichier set.set a été créé.";

    pAbout = gtk_message_dialog_new (GTK_WINDOW(data),
        GTK_DIALOG_MODAL,
        GTK_MESSAGE_INFO,
        GTK_BUTTONS_OK,
        "%s",
        sSite);

    /* Affichage de la boite de message */
    gtk_dialog_run(GTK_DIALOG(pAbout));

    /* Destruction de la boite de message */
    gtk_widget_destroy(pAbout);
}

void aide(gpointer data, guint callback_action,GtkWidget *widget)
{
    GtkWidget *aide = NULL;
    gchar *utf8 = NULL;

    utf8 = g_locale_to_utf8(
    "Ce programme  pour but de générer\n"
    "un fichier de set pour l'utiliser\n"
    "avec le CTQE.\n\nhttp://konosprod.free.fr/blog/?q=node/16"
    , -1, NULL, NULL, NULL);

    aide = gtk_message_dialog_new(GTK_WINDOW(data),
    GTK_DIALOG_MODAL,
    GTK_MESSAGE_INFO,
    GTK_BUTTONS_CLOSE,
    "%s", (char*)utf8);

    gtk_window_set_modal(GTK_WINDOW(aide), TRUE);

    gtk_dialog_run(GTK_DIALOG(aide));
    g_free(utf8);
    gtk_widget_destroy(aide);
}

void apropos(gpointer data, guint callback_action,GtkWidget *widget)
{
    GtkWidget *apropos = NULL;
    gchar *utf8;
    utf8 = g_locale_to_utf8(
    "Codé par Tartine.\nModifications autorisées et même encouragées.\n\nContact:\nkonosprod@free.fr", -1, NULL, NULL, NULL);

    apropos = gtk_message_dialog_new(GTK_WINDOW(data),
    GTK_DIALOG_MODAL,
    GTK_MESSAGE_INFO,
    GTK_BUTTONS_CLOSE,
    "%s", (char*)utf8
    );

    gtk_window_set_modal(GTK_WINDOW(apropos), TRUE);

    gtk_dialog_run(GTK_DIALOG(apropos));
    g_free(utf8);
    gtk_widget_destroy(apropos);
}

void quittem(gpointer data, guint callback_action,GtkWidget *widget)
{
    GtkWidget *confquit;

    confquit = gtk_message_dialog_new(GTK_WINDOW(data),
    GTK_DIALOG_MODAL,
    GTK_MESSAGE_QUESTION,
    GTK_BUTTONS_YES_NO,
    "Voulez-vous vraiment\n"
    "quitter le programme ?");

     gtk_window_set_modal(GTK_WINDOW(confquit), TRUE);

    switch(gtk_dialog_run(GTK_DIALOG(confquit)))
    {
        case GTK_RESPONSE_YES:
        quit();
        break;

        case GTK_RESPONSE_NONE:

        case GTK_RESPONSE_NO:
        gtk_widget_destroy(confquit);
        break;
    }
}
