/*  Custom Quest Set Generator - Main functions. Creating the GUI.

    Copyright (C) 2010-2011 Tartine

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include <stdlib.h>
#include <stdio.h>
#include <gtk/gtk.h>
#include "fonction.h"
#include "skin.h"


static GtkItemFactoryEntry MenuItem[] = {
    { "/_Fichier", NULL, NULL, 0, "<Branch>" },
    { "/Fichier/_Quitter", "<CTRL>Q", quittem, 1, "<StockItem>", GTK_STOCK_QUIT},
    { "/_?", NULL, NULL, 0, "<Branch>" },
    { "/?/_Aide", "<CTRL>H", aide ,1, "<StockItem>", GTK_STOCK_HELP},
    { "/?/_A propos de...", "<CTRL>A", apropos, 1, "<StockItem>", GTK_STOCK_HELP}
};

static gint numitem = sizeof(MenuItem) / sizeof(MenuItem[0]);

guint	g_timerID = 0;
GtkWidget *window_nothing_found = NULL;

gint DestroyHelperWindow ( gpointer pointer )
{
  GtkWidget* win = (GtkWidget*)pointer;
	if ( g_timerID )
		g_source_remove ( g_timerID );
	gtk_widget_destroy ( window_nothing_found );
	window_nothing_found = NULL;

  gtk_widget_show_all (win);
	return 1;
}

void	CreateHelperWindow (void)
{
  GtkWidget* image = NULL;
  GtkWidget* vbox = NULL;
  GtkWidget* label = NULL;

  window_nothing_found = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_window_set_position (GTK_WINDOW (window_nothing_found), GTK_WIN_POS_CENTER);
  gtk_window_set_resizable (GTK_WINDOW (window_nothing_found), FALSE);
  gtk_window_set_decorated (GTK_WINDOW (window_nothing_found), FALSE);
  gtk_window_set_skip_taskbar_hint (GTK_WINDOW (window_nothing_found), TRUE);
  gtk_window_set_skip_pager_hint (GTK_WINDOW (window_nothing_found), TRUE);
  gtk_window_set_type_hint (GTK_WINDOW (window_nothing_found), GDK_WINDOW_TYPE_HINT_SPLASHSCREEN);

  vbox = gtk_vbox_new(0, 0);

  gtk_container_add(GTK_CONTAINER(window_nothing_found), vbox);

  image = gtk_image_new_from_file("rc/splash.png");

  gtk_box_pack_start(GTK_BOX(vbox), image, 0, 0, 0);

  label = gtk_label_new("Chargement...");

  gtk_box_pack_start(GTK_BOX(vbox), label, 0, 0, 0);

  gtk_widget_show_all( window_nothing_found );
}

int main (int argc, char *argv[])
{
  GtkWidget* button = NULL;
  GtkWidget* win = NULL;
  GtkWidget* vbox = NULL;
  GtkWidget* vbox1 = NULL;
  GtkWidget* vbox2 = NULL;
  GtkWidget* vbox3 = NULL;
  GtkWidget* hbox1 = NULL;
  GtkWidget* hbox = NULL;
  GtkWidget* sw = NULL;
  GtkWidget *menu;
  GtkItemFactory *item;
  GtkAccelGroup *rac;
  Weapon arme;
  Set part[5];
  Object objets[25];
  int i = 0;

  /* Initialize GTK+ */
  g_log_set_handler ("Gtk", G_LOG_LEVEL_WARNING, (GLogFunc) gtk_false, NULL);
  gtk_init (&argc, &argv);
  g_log_set_handler ("Gtk", G_LOG_LEVEL_WARNING, g_log_default_handler, NULL);

  CreateHelperWindow();

  /* Create the main window */
  win = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_container_set_border_width (GTK_CONTAINER (win), 0);
  gtk_window_set_title (GTK_WINDOW (win), "Custom Quest Set Generator");
  gtk_window_set_position (GTK_WINDOW (win), GTK_WIN_POS_CENTER);
  gtk_widget_realize (win);
  g_signal_connect (win, "destroy", quit, NULL);

  /* Create a vertical box with buttons */
  vbox = gtk_vbox_new (0, 0);

    /*Creation de la table de racourcis*/
    rac = gtk_accel_group_new();
    /*Creation de la barre*/
    item = gtk_item_factory_new(GTK_TYPE_MENU_BAR, "<main>", rac);
    /*Recuperation des items du menu*/
    gtk_item_factory_create_items(item, numitem, MenuItem, (GtkWidget*) win);
    /*Recuperation du widget pour l'afficharge du menu*/
    menu = gtk_item_factory_get_widget(item, "<main>");
    /*Ajout du menu en haut*/
    gtk_box_pack_start(GTK_BOX(vbox), menu, 0, 0, 0);
    /*Ajout des racourcis a la fenetre*/
    gtk_window_add_accel_group(GTK_WINDOW(win), rac);

  gtk_container_add (GTK_CONTAINER (win), vbox);


  hbox1 = gtk_hbox_new(0, 0);
  hbox = gtk_hbox_new(0, 0);
  vbox1 = gtk_vbox_new(0, 0);
  vbox2 = gtk_vbox_new(0, 0);

  gtk_box_pack_start(GTK_BOX(vbox), hbox1, 0, 0, 0);
  gtk_box_pack_start(GTK_BOX(hbox1), vbox1, 1, 1, 0);
  gtk_box_pack_start(GTK_BOX(hbox1), vbox2, 1, 1, 0);

{ /********************     Création des ComboBox     ********************/

  arme.arme = gtk_combo_box_new_text();
  arme.j1 = gtk_combo_box_new_text();
  arme.j2 = gtk_combo_box_new_text();
  arme.j3 = gtk_combo_box_new_text();
  arme.swap = gtk_spin_button_new_with_range(5, 16, 1);
  gtk_box_pack_start(GTK_BOX(vbox1), hbox, 0, 0, 0);
  gtk_box_pack_start(GTK_BOX(hbox), arme.swap, 1, 1, 1);
  gtk_box_pack_start(GTK_BOX(hbox), arme.arme, 1, 1, 1);
  gtk_box_pack_start(GTK_BOX(hbox), arme.j1, 1, 1, 1);
  gtk_box_pack_start(GTK_BOX(hbox), arme.j2, 1, 1, 1);
  gtk_box_pack_start(GTK_BOX(hbox), arme.j3, 1, 1, 1);

  g_signal_connect(G_OBJECT(arme.swap), "changed", G_CALLBACK(aff_arme), GTK_COMBO_BOX(arme.arme));

  for(i = 0; i < 5; i++)
  {
    hbox = gtk_hbox_new(0, 1);
    part[i].part = gtk_combo_box_new_text();
    part[i].j1 = gtk_combo_box_new_text();
    part[i].j2 = gtk_combo_box_new_text();
    part[i].j3 = gtk_combo_box_new_text();
    gtk_box_pack_start(GTK_BOX(vbox1), hbox, 0, 0, 0);
    gtk_box_pack_start(GTK_BOX(hbox), part[i].part, 1, 1, 0);
    gtk_box_pack_start(GTK_BOX(hbox), part[i].j1, 1, 1, 0);
    gtk_box_pack_start(GTK_BOX(hbox), part[i].j2, 1, 1, 0);
    gtk_box_pack_start(GTK_BOX(hbox), part[i].j3, 1, 1, 0);
  }
}

{ /******************** Création de la boite à objets ********************/
  sw = gtk_scrolled_window_new(NULL, NULL);
  gtk_scrolled_window_set_shadow_type (GTK_SCROLLED_WINDOW (sw), GTK_SHADOW_ETCHED_IN);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (sw), GTK_POLICY_NEVER, GTK_POLICY_AUTOMATIC);
  gtk_box_pack_start (GTK_BOX (vbox2), sw, 1, 1, 0);
  vbox3 = gtk_vbox_new (0, 0);
  gtk_scrolled_window_add_with_viewport(GTK_SCROLLED_WINDOW(sw), GTK_WIDGET(vbox3));

  for(i = 0; i < 25; i++)
  {
    hbox = gtk_hbox_new(0, 1);
    objets[i].combo = gtk_combo_box_new_text();
    objets[i].spin = gtk_spin_button_new_with_range(0, 99, 1);
    gtk_box_pack_start(GTK_BOX(vbox3), hbox, 1, 1, 0);
    gtk_box_pack_start(GTK_BOX(hbox), objets[i].combo, 1, 1, 0);
    gtk_box_pack_start(GTK_BOX(hbox), objets[i].spin, 1, 1, 0);
    aff_objets(GTK_COMBO_BOX(objets[i].combo));
  }
}

{ /********************     Remplissage des boites    ********************/

  aff_cotte(GTK_COMBO_BOX(part[0].part));
  aff_joyau(GTK_COMBO_BOX(part[0].j1));
  aff_joyau(GTK_COMBO_BOX(part[0].j2));
  aff_joyau(GTK_COMBO_BOX(part[0].j3));

  aff_gants(GTK_COMBO_BOX(part[1].part));
  aff_joyau(GTK_COMBO_BOX(part[1].j1));
  aff_joyau(GTK_COMBO_BOX(part[1].j2));
  aff_joyau(GTK_COMBO_BOX(part[1].j3));

  aff_taille(GTK_COMBO_BOX(part[2].part));
  aff_joyau(GTK_COMBO_BOX(part[2].j1));
  aff_joyau(GTK_COMBO_BOX(part[2].j2));
  aff_joyau(GTK_COMBO_BOX(part[2].j3));

  aff_jambes(GTK_COMBO_BOX(part[3].part));
  aff_joyau(GTK_COMBO_BOX(part[3].j1));
  aff_joyau(GTK_COMBO_BOX(part[3].j2));
  aff_joyau(GTK_COMBO_BOX(part[3].j3));

  aff_casque(GTK_COMBO_BOX(part[4].part));
  aff_joyau(GTK_COMBO_BOX(part[4].j1));
  aff_joyau(GTK_COMBO_BOX(part[4].j2));
  aff_joyau(GTK_COMBO_BOX(part[4].j3));

  aff_joyau(GTK_COMBO_BOX(arme.j1));
  aff_joyau(GTK_COMBO_BOX(arme.j2));
  aff_joyau(GTK_COMBO_BOX(arme.j3));
}

  hbox = gtk_hbox_new(0, 0);
  button = gtk_button_new_with_label("Générer");
  gtk_box_pack_start(GTK_BOX(vbox), hbox, 0, 0, 0);
  gtk_box_pack_start(GTK_BOX(hbox), button, 1, 0, 0);
  g_signal_connect(G_OBJECT(button), "clicked", G_CALLBACK(print_cotte), &part[0]);
  g_signal_connect(G_OBJECT(button), "clicked", G_CALLBACK(print_gants), &part[1]);
  g_signal_connect(G_OBJECT(button), "clicked", G_CALLBACK(print_taille), &part[2]);
  g_signal_connect(G_OBJECT(button), "clicked", G_CALLBACK(print_jambes), &part[3]);
  g_signal_connect(G_OBJECT(button), "clicked", G_CALLBACK(print_casque), &part[4]);
  g_signal_connect(G_OBJECT(button), "clicked", G_CALLBACK(print_arme), &arme);
  for(i = 0; i < 25; i++)
  {
    g_signal_connect(G_OBJECT(button), "clicked", G_CALLBACK(count_obj), &objets[i]);
  }
  g_signal_connect(G_OBJECT(button), "clicked", G_CALLBACK(print_nb), NULL);
  for(i = 0; i < 25; i++)
  {
    g_signal_connect(G_OBJECT(button), "clicked", G_CALLBACK(print_objet), &objets[i]);
  }
  g_signal_connect(G_OBJECT(button), "clicked", G_CALLBACK(done), win);

  g_timerID = g_timeout_add (5000, DestroyHelperWindow, win);

  /* Enter the main loop */
  gtk_main ();
  return 0;
}
